Index: issm/trunk/src/m/boundaryconditions/SetIceSheetBC.m
===================================================================
--- issm/trunk/src/m/boundaryconditions/SetIceSheetBC.m	(revision 25994)
+++ issm/trunk/src/m/boundaryconditions/SetIceSheetBC.m	(revision 26744)
@@ -31,5 +31,8 @@
 %Initialize surface and basal forcings
 md.smb = initialize(md.smb,md);
-md.basalforcings   = initialize(md.basalforcings,md);
+md.basalforcings = initialize(md.basalforcings,md);
+
+%Initialize ocean forcings and sealevel
+md.dsl = initialize(md.dsl,md);
 
 %Deal with other boundary conditions
Index: issm/trunk/src/m/boundaryconditions/SetIceSheetBC.py
===================================================================
--- issm/trunk/src/m/boundaryconditions/SetIceSheetBC.py	(revision 25994)
+++ issm/trunk/src/m/boundaryconditions/SetIceSheetBC.py	(revision 26744)
@@ -3,55 +3,57 @@
 
 def SetIceSheetBC(md):
-    """
-    SETICESHEETBC - Create the boundary conditions for stressbalance and thermal models for an IceSheet with no Ice Front
+    """SETICESHEETBC - Create the boundary conditions for stressbalance and thermal models for an IceSheet with no Ice Front
 
-       Usage:
-          md = SetIceSheetBC(md)
+    Usage:
+        md = SetIceSheetBC(md)
 
-       See also: SETICESHELFBC, SETMARINEICESHEETBC
+    See also: SETICESHELFBC, SETMARINEICESHEETBC
     """
 
-    #node on Dirichlet
+    # node on Dirichlet
     pos = np.nonzero(md.mesh.vertexonboundary)
-    md.stressbalance.spcvx = float('nan') * np.ones((md.mesh.numberofvertices))
-    md.stressbalance.spcvy = float('nan') * np.ones((md.mesh.numberofvertices))
-    md.stressbalance.spcvz = float('nan') * np.ones((md.mesh.numberofvertices))
+    md.stressbalance.spcvx = np.nan * np.ones((md.mesh.numberofvertices))
+    md.stressbalance.spcvy = np.nan * np.ones((md.mesh.numberofvertices))
+    md.stressbalance.spcvz = np.nan * np.ones((md.mesh.numberofvertices))
     md.stressbalance.spcvx[pos] = 0
     md.stressbalance.spcvy[pos] = 0
     md.stressbalance.spcvz[pos] = 0
-    md.stressbalance.referential = float('nan') * np.ones((md.mesh.numberofvertices, 6))
+    md.stressbalance.referential = np.nan * np.ones((md.mesh.numberofvertices, 6))
     md.stressbalance.loadingforce = 0 * np.ones((md.mesh.numberofvertices, 3))
 
-    #Dirichlet Values
+    # Dirichlet Values
     if isinstance(md.inversion.vx_obs, np.ndarray) and np.size(md.inversion.vx_obs, axis=0) == md.mesh.numberofvertices and isinstance(md.inversion.vy_obs, np.ndarray) and np.size(md.inversion.vy_obs, axis=0) == md.mesh.numberofvertices:
-        print("      boundary conditions for stressbalance model: spc set as observed velocities")
+        print('      boundary conditions for stressbalance model: spc set as observed velocities')
         md.stressbalance.spcvx[pos] = md.inversion.vx_obs[pos]
         md.stressbalance.spcvy[pos] = md.inversion.vy_obs[pos]
     else:
-        print("      boundary conditions for stressbalance model: spc set as zero")
+        print('      boundary conditions for stressbalance model: spc set as zero')
 
-    #No ice front -> do nothing
+    # No ice front -> do nothing
 
-    #Create zeros basalforcings and smb
+    # Initialize surface and basal forcings
     md.smb.initialize(md)
     md.basalforcings.initialize(md)
 
-    #Deal with other boundary conditions
+    # Initialize ocean forcings and sealevel
+    md.dsl.initialize(md)
+
+    # Deal with other boundary conditions
     if np.all(np.isnan(md.balancethickness.thickening_rate)):
         md.balancethickness.thickening_rate = np.zeros((md.mesh.numberofvertices))
-        print("      no balancethickness.thickening_rate specified: values set as zero")
-    md.masstransport.spcthickness = float('nan') * np.ones((md.mesh.numberofvertices))
-    md.balancethickness.spcthickness = float('nan') * np.ones((md.mesh.numberofvertices))
-    md.damage.spcdamage = float('nan') * np.ones((md.mesh.numberofvertices))
+        print('      no balancethickness.thickening_rate specified: values set as zero')
+    md.masstransport.spcthickness = np.nan * np.ones((md.mesh.numberofvertices))
+    md.balancethickness.spcthickness = np.nan * np.ones((md.mesh.numberofvertices))
+    md.damage.spcdamage = np.nan * np.ones((md.mesh.numberofvertices))
 
     if isinstance(md.initialization.temperature, np.ndarray) and np.size(md.initialization.temperature, axis=0) == md.mesh.numberofvertices:
-        md.thermal.spctemperature = float('nan') * np.ones((md.mesh.numberofvertices))
+        md.thermal.spctemperature = np.nan * np.ones((md.mesh.numberofvertices))
         if hasattr(md.mesh, 'vertexonsurface'):
             pos = np.nonzero(md.mesh.vertexonsurface)[0]
-            md.thermal.spctemperature[pos] = md.initialization.temperature[pos]  #impose observed temperature on surface
+            md.thermal.spctemperature[pos] = md.initialization.temperature[pos]  # impose observed temperature on surface
         if not isinstance(md.basalforcings.geothermalflux, np.ndarray) or not np.size(md.basalforcings.geothermalflux) == md.mesh.numberofvertices:
-            md.basalforcings.geothermalflux = 50. * 10**-3 * np.ones((md.mesh.numberofvertices))  #50 mW / m^2
+            md.basalforcings.geothermalflux = 50.0 * pow(10, -3) * np.ones((md.mesh.numberofvertices))  # 50 mW/m^2
     else:
-        print("      no thermal boundary conditions created: no observed temperature found")
+        print('      no thermal boundary conditions created: no observed temperature found')
 
     return md
Index: issm/trunk/src/m/boundaryconditions/SetMLHOBC.m
===================================================================
--- issm/trunk/src/m/boundaryconditions/SetMLHOBC.m	(revision 26744)
+++ issm/trunk/src/m/boundaryconditions/SetMLHOBC.m	(revision 26744)
@@ -0,0 +1,16 @@
+function md=SetMLHOBC(md)
+%SETMLHOBC - Create the boundary conditions for stressbalance for MLHO: VxBase, VyBase, VxShear, VyShear
+%
+%   Usage:
+%      md=SetMLHOBC(md)
+%
+
+
+%node on Dirichlet
+if md.flowequation.isMLHO
+	md.stressbalance.spcvx_base=md.stressbalance.spcvx;
+	md.stressbalance.spcvy_base=md.stressbalance.spcvy;
+
+	md.stressbalance.spcvx_shear=NaN*ones(size(md.stressbalance.spcvx_base));
+	md.stressbalance.spcvy_shear=NaN*ones(size(md.stressbalance.spcvy_base));
+end
Index: issm/trunk/src/m/boundaryconditions/SetMLHOBC.py
===================================================================
--- issm/trunk/src/m/boundaryconditions/SetMLHOBC.py	(revision 26744)
+++ issm/trunk/src/m/boundaryconditions/SetMLHOBC.py	(revision 26744)
@@ -0,0 +1,22 @@
+import numpy as np
+
+
+def SetMLHOBC(md):
+    """
+    SETMLHOBC - Create the boundary conditions for stressbalance for MLHO: VxBase, VyBase, VxShear, VyShear
+
+       Usage:
+          md = SetIceShelfBC(md, varargin)
+
+       Example:
+          md = SetIceShelfBC(md)
+
+    """
+
+    #node on Dirichlet (boundary and ~icefront)
+    md.stressbalance.spcvx_base = md.stressbalance.spcvx
+    md.stressbalance.spcvy_base = md.stressbalance.spcvy
+    md.stressbalance.spcvx_shear = np.nan * md.stressbalance.spcvx
+    md.stressbalance.spcvy_shear = np.nan * md.stressbalance.spcvy
+
+    return md
Index: issm/trunk/src/m/boundaryconditions/SetMarineIceSheetBC.m
===================================================================
--- issm/trunk/src/m/boundaryconditions/SetMarineIceSheetBC.m	(revision 25994)
+++ issm/trunk/src/m/boundaryconditions/SetMarineIceSheetBC.m	(revision 26744)
@@ -40,5 +40,5 @@
 pos=find(md.mesh.vertexonboundary & ~vertexonicefront);
 if isempty(pos),
-	disp('SetMarineIceSheetBC warning: ice front all around the glacier, no dirichlet applied')
+	disp('Warning: SetMarineIceSheetBC.m: ice front all around the glacier, no dirichlet applied')
 end
 md.stressbalance.spcvx=NaN*ones(md.mesh.numberofvertices,1);
Index: issm/trunk/src/m/boundaryconditions/SetMarineIceSheetBC.py
===================================================================
--- issm/trunk/src/m/boundaryconditions/SetMarineIceSheetBC.py	(revision 25994)
+++ issm/trunk/src/m/boundaryconditions/SetMarineIceSheetBC.py	(revision 26744)
@@ -5,51 +5,51 @@
 
 def SetMarineIceSheetBC(md, icefrontfile=''):
-    """
-    SETICEMARINESHEETBC - Create the boundary conditions for stressbalance and thermal models for a  Marine Ice Sheet with Ice Front
+    """SETICEMARINESHEETBC - Create the boundary conditions for stressbalance 
+    and thermal models for a  Marine Ice Sheet with Ice Front
 
-       Neumann BC are used on the ice front (an ARGUS contour around the ice front
-       can be given in input, or it will be deduced as onfloatingice & onboundary)
-       Dirichlet BC are used elsewhere for stressbalance
+    Neumann BC are used on the ice front (an ARGUS contour around the ice front
+    can be given in input, or it will be deduced as onfloatingice & onboundary)
+    Dirichlet BC are used elsewhere for stressbalance
 
-       Usage:
-          md = SetMarineIceSheetBC(md, icefrontfile)
-          md = SetMarineIceSheetBC(md)
+    Usage:
+        md = SetMarineIceSheetBC(md, icefrontfile)
+        md = SetMarineIceSheetBC(md)
 
-       Example:
-          md = SetMarineIceSheetBC(md, 'Front.exp')
-          md = SetMarineIceSheetBC(md)
+    Example:
+        md = SetMarineIceSheetBC(md, 'Front.exp')
+        md = SetMarineIceSheetBC(md)
 
-       See also: SETICESHELFBC, SETMARINEICESHEETBC
+    See also: SETICESHELFBC, SETMARINEICESHEETBC
     """
     #node on Dirichlet (boundary and ~icefront)
     if icefrontfile:
-        #User provided Front.exp, use it
+        # User provided Front.exp, use it
         if not os.path.exists(icefrontfile):
-            raise IOError("SetMarineIceSheetBC error message: ice front file '%s' not found." % icefrontfile)
+            raise IOError('SetMarineIceSheetBC error message: ice front file \'{}\' not found.'.format(icefrontfile))
         incontour = ContourToMesh(md.mesh.elements, md.mesh.x, md.mesh.y, icefrontfile, 'node', 2)
         vertexonicefront = np.logical_and(md.mesh.vertexonboundary, incontour.reshape(-1))
     else:
-        #Guess where the ice front is
+        # Guess where the ice front is
         vertexonfloatingice = np.zeros((md.mesh.numberofvertices))
-        pos = np.nonzero(np.sum(md.mask.ocean_levelset[md.mesh.elements - 1] < 0., axis=1) > 0.)[0]
+        pos = np.nonzero(np.sum(md.mask.ocean_levelset[md.mesh.elements - 1] < 0.0, axis=1) > 0.0)[0]
         vertexonfloatingice[md.mesh.elements[pos].astype(int) - 1] = 1.
-        vertexonicefront = np.logical_and(np.reshape(md.mesh.vertexonboundary, (-1, )), vertexonfloatingice > 0.)
+        vertexonicefront = np.logical_and(np.reshape(md.mesh.vertexonboundary, (-1, )), vertexonfloatingice > 0.0)
 
     #pos = find(md.mesh.vertexonboundary & ~vertexonicefront)
     pos = np.nonzero(np.logical_and(md.mesh.vertexonboundary, np.logical_not(vertexonicefront)))[0]
     if not np.size(pos):
-        print("SetMarineIceSheetBC warning: ice front all around the glacier, no dirichlet found. Dirichlet must be added manually.")
+        print('Warning: SetMarineIceSheetBC.py: ice front all around the glacier, no dirichlet found. Dirichlet must be added manually.')
 
-    md.stressbalance.spcvx = float('nan') * np.ones(md.mesh.numberofvertices)
-    md.stressbalance.spcvy = float('nan') * np.ones(md.mesh.numberofvertices)
-    md.stressbalance.spcvz = float('nan') * np.ones(md.mesh.numberofvertices)
-    md.stressbalance.referential = float('nan') * np.ones((md.mesh.numberofvertices, 6))
+    md.stressbalance.spcvx = np.nan * np.ones(md.mesh.numberofvertices)
+    md.stressbalance.spcvy = np.nan * np.ones(md.mesh.numberofvertices)
+    md.stressbalance.spcvz = np.nan * np.ones(md.mesh.numberofvertices)
+    md.stressbalance.referential = np.nan * np.ones((md.mesh.numberofvertices, 6))
     md.stressbalance.loadingforce = 0 * np.ones((md.mesh.numberofvertices, 3))
 
-    #Position of ice front
+    # Position of ice front
     pos = np.nonzero(vertexonicefront)[0]
     md.mask.ice_levelset[pos] = 0
 
-    #First find segments that are not completely on the front
+    # First find segments that are not completely on the front
     if md.mesh.elementtype() == 'Penta':
         numbernodesfront = 4
@@ -57,5 +57,5 @@
         numbernodesfront = 2
     else:
-        raise Exception("Mesh type not supported")
+        raise Exception('Mesh type not supported')
     if any(md.mask.ice_levelset <= 0):
         values = md.mask.ice_levelset[md.mesh.segments[:, 0:-1] - 1]
@@ -63,5 +63,5 @@
         np.sum(segmentsfront, axis=1) != numbernodesfront
         segments = np.nonzero(np.sum(segmentsfront, axis=1) != numbernodesfront)[0]
-    #Find all nodes for these segments and spc them
+        # Find all nodes for these segments and spc them
         pos = md.mesh.segments[segments, 0:-1] - 1
     else:
@@ -71,11 +71,11 @@
     md.stressbalance.spcvz[pos] = 0
 
-    #Dirichlet Values
+    # Dirichlet Values
     if isinstance(md.inversion.vx_obs, np.ndarray) and np.size(md.inversion.vx_obs, axis=0) == md.mesh.numberofvertices and isinstance(md.inversion.vy_obs, np.ndarray) and np.size(md.inversion.vy_obs, axis=0) == md.mesh.numberofvertices:
-        print("      boundary conditions for stressbalance model: spc set as observed velocities")
+        print('      boundary conditions for stressbalance model: spc set as observed velocities')
         md.stressbalance.spcvx[pos] = md.inversion.vx_obs[pos]
         md.stressbalance.spcvy[pos] = md.inversion.vy_obs[pos]
     else:
-        print("      boundary conditions for stressbalance model: spc set as zero")
+        print('      boundary conditions for stressbalance model: spc set as zero')
 
     md.hydrology.spcwatercolumn = np.zeros((md.mesh.numberofvertices, 2))
@@ -90,20 +90,20 @@
     if np.all(np.isnan(md.balancethickness.thickening_rate)):
         md.balancethickness.thickening_rate = np.zeros((md.mesh.numberofvertices))
-        print("      no balancethickness.thickening_rate specified: values set as zero")
+        print('      no balancethickness.thickening_rate specified: values set as zero')
 
-    md.masstransport.spcthickness = float('nan') * np.ones((md.mesh.numberofvertices))
-    md.balancethickness.spcthickness = float('nan') * np.ones((md.mesh.numberofvertices))
-    md.damage.spcdamage = float('nan') * np.ones((md.mesh.numberofvertices))
+    md.masstransport.spcthickness = np.nan * np.ones((md.mesh.numberofvertices))
+    md.balancethickness.spcthickness = np.nan * np.ones((md.mesh.numberofvertices))
+    md.damage.spcdamage = np.nan * np.ones((md.mesh.numberofvertices))
 
     if isinstance(md.initialization.temperature, np.ndarray) and np.size(md.initialization.temperature, axis=0) == md.mesh.numberofvertices:
-        md.thermal.spctemperature = float('nan') * np.ones((md.mesh.numberofvertices))
+        md.thermal.spctemperature = np.nan * np.ones((md.mesh.numberofvertices))
         if hasattr(md.mesh, 'vertexonsurface'):
             pos = np.nonzero(md.mesh.vertexonsurface)[0]
-            md.thermal.spctemperature[pos] = md.initialization.temperature[pos]  #impose observed temperature on surface
+            md.thermal.spctemperature[pos] = md.initialization.temperature[pos]  # impose observed temperature on surface
         if not isinstance(md.basalforcings.geothermalflux, np.ndarray) or not np.size(md.basalforcings.geothermalflux, axis=0) == md.mesh.numberofvertices:
             md.basalforcings.geothermalflux = np.zeros((md.mesh.numberofvertices))
-            md.basalforcings.geothermalflux[np.nonzero(md.mask.ocean_levelset > 0.)] = 50. * 10.**- 3  #50mW / m2
+            md.basalforcings.geothermalflux[np.nonzero(md.mask.ocean_levelset > 0.0)] = 50.0 * pow(10.0, -3)  # 50mW/m2
     else:
-        print("      no thermal boundary conditions created: no observed temperature found")
+        print('      no thermal boundary conditions created: no observed temperature found')
 
     return md
Index: issm/trunk/src/m/boundaryconditions/getlovenumbers.py
===================================================================
--- issm/trunk/src/m/boundaryconditions/getlovenumbers.py	(revision 25994)
+++ issm/trunk/src/m/boundaryconditions/getlovenumbers.py	(revision 26744)
@@ -5,21 +5,25 @@
 
 def getlovenumbers(*args): #{{{
-    '''
-    GETLOVENUMBERS - provide love numbers retrieved from: 
+    """GETLOVENUMBERS - provide love numbers retrieved from: 
     http://www.srosat.com/iag-jsg/loveNb.php in a chosen reference frame
 
-        Usage:
-            series = love_numbers('type', 'loadingverticaldisplacement', 'referenceframe', 'CM', 'maxdeg', 1001)
+    Usage:
+        series = love_numbers('type', 'loadingverticaldisplacement', 'referenceframe', 'CM', 'maxdeg', 1001)
 
-        - type = one of 'loadingverticaldisplacement', 
-        'loadinggravitationalpotential', 'loadinghorizontaldisplacement', 
-        'tidalverticaldisplacement', 'tidalgravitationalpotential', 
-        'tidalhorizontaldisplacement'
-        - reference_frame = one of 'CM' (default) and 'CF'
-        - maxdeg = default 1000
+    - type = one of 'loadingverticaldisplacement', 
+    'loadinggravitationalpotential', 'loadinghorizontaldisplacement', 
+    'tidalverticaldisplacement', 'tidalgravitationalpotential', 
+    'tidalhorizontaldisplacement'
+    - reference_frame = one of 'CM' (default) and 'CF'
+    - maxdeg = default 1000
 
-        Example:
-            h = love_number
-    '''
+    Example:
+        h = getlovenumbers('type', 'loadingverticaldisplacement', 'referenceframe', 'CM', 'maxdeg', maxdeg)
+        k = getlovenumbers('type', 'loadinggravitationalpotential', 'referenceframe', 'CM', 'maxdeg', maxdeg)
+        l = getlovenumbers('type', 'loadinghorizontaldisplacement', 'referenceframe', 'CM', 'maxdeg', maxdeg)
+        th = getlovenumbers('type', 'tidalverticaldisplacement', 'referenceframe', 'CM', 'maxdeg', maxdeg)
+        tk = getlovenumbers('type', 'tidalgravitationalpotential', 'referenceframe', 'CM', 'maxdeg', maxdeg)
+        tl = getlovenumbers('type', 'tidalhorizontaldisplacement', 'referenceframe', 'CM', 'maxdeg', maxdeg)
+    """
 
     TYPES = [
@@ -32,9 +36,12 @@
     ]
 
-    #recover options
+    # Recover options
     options = pairoptions(*args)
     type = options.getfieldvalue('type')
     frame = options.getfieldvalue('referenceframe', 'CM')
     maxdeg = options.getfieldvalue('maxdeg', 1000)
+
+    if (maxdeg > 10000):
+        raise Exception('PREM love numbers computed only for deg < 10,000. Request lower maxdeg')
 
     if type not in TYPES:
@@ -10045,8 +10052,8 @@
     ])
 
-    #cut off series at maxdeg
+    # Cut off series at maxdeg
     love_numbers = np.delete(love_numbers, range(maxdeg + 1, len(love_numbers)), axis=0)
 
-    #retrieve right type
+    # Retrieve right type
     if type == 'loadingverticaldisplacement':
         series = love_numbers[:, 0]
@@ -10062,5 +10069,5 @@
         series = love_numbers[:, 5]
     else:
-        raise Exception("love_numbers error message: unknown type: {}".format(type))
+        raise Exception('love_numbers error message: unknown type: {}'.format(type))
 
     #choose degree 1 term for CF reference system
@@ -10075,5 +10082,5 @@
             series[1] = 0.134
     else:
-        raise Exception("love_numbers error message: unknown reference frame: {}".format(frame))
+        raise Exception('love_numbers error message: unknown reference frame: {}'.format(frame))
 
     return series
Index: issm/trunk/src/m/classes/SMBautoregression.m
===================================================================
--- issm/trunk/src/m/classes/SMBautoregression.m	(revision 26744)
+++ issm/trunk/src/m/classes/SMBautoregression.m	(revision 26744)
@@ -0,0 +1,122 @@
+%SMBautoregression Class definition
+%
+%   Usage:
+%      SMBautoregression=SMBautoregression();
+
+classdef SMBautoregression
+	properties (SetAccess=public)
+		num_basins        = 0;
+		beta0             = NaN;
+		beta1             = NaN;
+		ar_order          = 0;
+		ar_initialtime    = 0;
+		ar_timestep       = 0;
+		phi               = NaN;
+		basin_id          = NaN;
+		steps_per_step    = 1;
+		averaging         = 0;
+		requested_outputs = {};
+	end
+	methods
+		function self = SMBautoregression(varargin) % {{{
+			switch nargin
+				case 0
+					self=setdefaultparameters(self);
+				otherwise
+					error('constructor not supported');
+			end
+		end % }}}
+		function self = extrude(self,md) % {{{
+			%Nothing for now
+		end % }}}
+		function list = defaultoutputs(self,md) % {{{
+			list = {''};
+		end % }}}
+		function self = initialize(self,md) % {{{
+			if isnan(self.beta1)
+				self.beta1 = zeros(1,self.num_basins); %no trend in SMB
+				disp('      smb.beta1 (trend) not specified: value set to 0');
+			end
+			if (self.ar_order==0)
+				self.ar_order = 1; %dummy 1 value for autoregression
+				self.phi      = zeros(self.num_basins,self.ar_order); %autoregression coefficients all set to 0 
+				disp('      smb.ar_order (order of autoregressive model) not specified: order of autoregressive model set to 0');
+			end
+			if (self.ar_initialtime==0)
+				self.ar_initialtime = md.timestepping.start_time; %autoregression model has no prescribed initial time
+				disp('      smb.ar_initialtime (initial time in the autoregressive model parameterization) not specified: set to md.timestepping.start_time');
+			end
+			if (self.ar_timestep==0)
+				self.ar_timestep = md.timestepping.time_step; %autoregression model has no prescribed time step
+				disp('      smb.ar_timestep (timestep of autoregressive model) not specified: set to md.timestepping.time_step');
+			end
+			if isnan(self.phi)
+				self.phi = zeros(self.num_basins,self.ar_order); %autoregression model of order 0 
+				disp('      smb.phi (lag coefficients) not specified: order of autoregressive model set to 0');
+			end
+		end % }}}
+		function self = setdefaultparameters(self) % {{{
+			self.ar_order    = 0.0; %autoregression model of order 0
+		end % }}}
+		function md = checkconsistency(self,md,solution,analyses) 
+
+			if ismember('MasstransportAnalysis',analyses),
+				md = checkfield(md,'fieldname','smb.num_basins','numel',1,'NaN',1,'Inf',1,'>',0);
+				md = checkfield(md,'fieldname','smb.basin_id','Inf',1,'>=',0,'<=',md.smb.num_basins,'size',[md.mesh.numberofelements,1]);
+				md = checkfield(md,'fieldname','smb.beta0','NaN',1,'Inf',1,'size',[1,md.smb.num_basins],'numel',md.smb.num_basins); %scheme fails if passed as column vector
+				md = checkfield(md,'fieldname','smb.beta1','NaN',1,'Inf',1,'size',[1,md.smb.num_basins],'numel',md.smb.num_basins); %scheme fails if passed as column vector
+				md = checkfield(md,'fieldname','smb.ar_order','numel',1,'NaN',1,'Inf',1,'>=',0);
+				md = checkfield(md,'fieldname','smb.ar_initialtime','numel',1,'NaN',1,'Inf',1); 
+				md = checkfield(md,'fieldname','smb.ar_timestep','numel',1,'NaN',1,'Inf',1,'>=',md.timestepping.time_step); %autoregression time step cannot be finer than ISSM timestep
+				md = checkfield(md,'fieldname','smb.phi','NaN',1,'Inf',1,'size',[md.smb.num_basins,md.smb.ar_order]);
+			end
+			md = checkfield(md,'fieldname','smb.steps_per_step','>=',1,'numel',[1]);
+			md = checkfield(md,'fieldname','smb.averaging','numel',[1],'values',[0 1 2]);
+			md = checkfield(md,'fieldname','smb.requested_outputs','stringrow',1);
+		end 
+		function disp(self) % {{{
+			disp(sprintf('   surface forcings parameters:'));
+			fielddisplay(self,'num_basins','number of different basins [unitless]');
+			fielddisplay(self,'basin_id','basin number assigned to each element [unitless]');
+			fielddisplay(self,'beta0','basin-specific intercept values [m ice eq./yr]');
+			fielddisplay(self,'beta1','basin-specific trend values [m ice eq. yr^(-2)]');
+			fielddisplay(self,'ar_order','order of the autoregressive model [unitless]');
+			fielddisplay(self,'ar_initialtime','initial time assumed in the autoregressive model parameterization [yr]');
+			fielddisplay(self,'ar_timestep','time resolution of the autoregressive model [yr]');
+			fielddisplay(self,'phi','basin-specific vectors of lag coefficients [unitless]');
+			fielddisplay(self, 'steps_per_step', 'number of smb steps per time step');
+			fielddisplay(self, 'averaging', 'averaging methods from short to long steps');
+			disp(sprintf('%51s  0: Arithmetic (default)',' '));
+			disp(sprintf('%51s  1: Geometric',' '));
+			disp(sprintf('%51s  2: Harmonic',' '));
+			fielddisplay(self,'requested_outputs','additional outputs requested');
+
+		end % }}}
+		function marshall(self,prefix,md,fid) % {{{
+
+			yts=md.constants.yts;
+
+			WriteData(fid,prefix,'name','md.smb.model','data',55,'format','Integer');
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','num_basins','format','Integer');
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','ar_order','format','Integer');
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','ar_initialtime','format','Double','scale',yts);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','ar_timestep','format','Double','scale',yts);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','basin_id','data',self.basin_id-1,'name','md.smb.basin_id','format','IntMat','mattype',2); %0-indexed
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','beta0','format','DoubleMat','name','md.smb.beta0','scale',1./yts,'yts',yts);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','beta1','format','DoubleMat','name','md.smb.beta1','scale',1./(yts^2),'yts',yts);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','phi','format','DoubleMat','name','md.smb.phi','yts',yts); 
+			WriteData(fid,prefix,'object',self,'fieldname','steps_per_step','format','Integer');
+			WriteData(fid,prefix,'object',self,'fieldname','averaging','format','Integer');
+
+			%process requested outputs
+			outputs = self.requested_outputs;
+			pos  = find(ismember(outputs,'default'));
+			if ~isempty(pos),
+				outputs(pos) = [];                         %remove 'default' from outputs
+				outputs      = [outputs defaultoutputs(self,md)]; %add defaults
+			end
+			WriteData(fid,prefix,'data',outputs,'name','md.smb.requested_outputs','format','StringArray');
+
+		end % }}}
+	end
+end
